module Access  ( Access(..), AccessType(..), intToAccessType, 
		 getNrBoundsOfAccess ) where


import LMath.LinAlg

data AccessType = Read | Write deriving(Show,Eq)

intToAccessType 0 = Read
intToAccessType 1 = Write
intToAccessType _ = error ("unknown access type")


data Access = Access { accessId   :: Integer,
		       indexFct   :: AffineFunction,
		       stmtId     :: Integer,
		       domain     :: IneqSystem,
		       accessType :: AccessType,  -- ,
		       arrayID    :: Integer
		       } deriving Show


-- instance Show Access where
--   show acc = "Access with function " ++ show (getFunctionOfAccess acc) ++
--     " with " ++ show (getNrBoundsOfAccess acc) ++ " bounds.\n"



getNrBoundsOfAccess :: Access -> Integer
getNrBoundsOfAccess = nRows . domain

