module Main
where

{-
import Tiling(defaultTiledLoops,TileInformation(..),
              defaultTile)
import LoopoDS
import Maybe
import Ix
import List
import Ratio
import InsertIfs.Parser(parseSource)
import Data.Map
-}

import System(getArgs)

import CompSpread.Data
import CompSpread.DomainDescriptions
import CompSpread.DomainGen
import CompSpread.ScatterFunctions
import CompSpread.CloogStatements
import CompSpread.Run

main :: IO ()
main = 
  do 
  inputStr <- getArgs
  let cl = parseCommandLine inputStr
      csDS = unsafeCreateCompSpreadDS cl
      cloogStatements = genMainCloogStatements csDS
      rpMapStatements = genRPMapStatements csDS
      rpMapData = RPMapStatements { rpmStmts = rpMapStatements } 
      mainRun = RunMainProg
      rpMapRun = RunRealProcMapping { runRPdim = getRPdim csDS }

  putStrLn "writing defines-file..."
  writeDefinesFile csDS cloogStatements
  putStrLn "main defines-file done."

  putStrLn "writing rpMap-defines-file..."
  writeRPMapDefinesFile csDS rpMapData
  putStrLn "main rpMap-defines-file done."

  putStrLn "generating main input.."
  writeMainInputFile csDS cloogStatements mainRun
  putStrLn "main input generated."

  putStrLn "running CLooG..."
  runCloog csDS mainRun 
  putStrLn "CLooG done."

  putStrLn "postprocessing CLooG-output..."
  runPostprocessing csDS
  putStrLn "insertIFs done."

  putStrLn "generating rp-map input.."
  writeRPMapInputFile csDS rpMapData rpMapRun
  putStrLn "rpMap input generated."


  putStrLn "running CLooG (rp-map run)..."
  runCloog csDS rpMapRun
  putStrLn "CLooG (rp-map run) done."

