#ifndef _CPPSIDE_H
#define _CPPSIDE_H

#ifdef __cplusplus
extern "C" {
#endif
    typedef void *Pair;
    Pair mkPair(void *a, void *b);
#ifdef __cplusplus
}
#endif

#ifndef _IN_GHC_

/*
 * When compiled with polylibMP, we need to call
 * gmp_protect() and gmp_unprotect() (defined in hsinterface.cc)
 * to protect GMP's vs GHC's memory handling.
 * Otherwise, we define gmp_protect() and gmp_unprotect() to be
 * empty inline functions.
 */
#if POLYLIB_BITS==gmp
    extern void gmp_protect();
    extern void gmp_unprotect();
#else
    static inline void gmp_protect() { }
    static inline void gmp_unprotect() { }
#endif

void oomInLoopo(void);

/* !def _IN_GHC_ */
#endif

/* !def _CPPSIDE_H */
#endif
