#ifndef _BARVINOKPOLYLIB_H
#define _BARVINOKPOLYLIB_H

#include "CppSide.h"

#ifndef _IN_GHC_

#ifdef HAVE_BARVINOK
#include <barvinok/evalue.h>
#include <barvinok/barvinok.h>
#else
#if POLYLIB_BITS==64
extern "C" {
#include <polylib/polylib64.h>
}
#else
#include <gmp.h>
extern "C" {
#include <polylib/polylibgmp.h>
}
#endif
#endif

#else
#include "polylib.h"

/* !def _IN_GHC_ */
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Ehrhart functions
 */

Pair *countIntegralPoints_c(Polyhedron *ineqs, Polyhedron *context);
void evalueFree_c(evalue *ev);
Value* evalueGetD_c(evalue *ev);
Value* evalueGetN_c(evalue *ev);
enode* evalueGetP_c(evalue *ev);
int enodeIsPeriodic_c(enode *en);
int enodeGetParameterPos_c(enode *en);
evalue** enodeGetValues_c(enode *en);

#ifdef __cplusplus
}
#endif


/* !def _BARVINOKPOLYLIB_H */
#endif
