module ISS.DataSplitting.Info(SplitInfo, DepSplitInfo, LaNodeSplitInfo) where


import LMath.Types.IneqSystem
import LoopoDS.Dependence
import LoopoDS.Statement


-- |Map, which tells us to every old statement-ID the new statement-IDs
--  (after splitting of the parse tree) and the corresponding index spaces

--                   old ID         new ID      new Index-Space
type SplitInfo = [(StatementID,[(StatementID, GIneqSystem Rational)])]


-- |Map, which tells us to every old dependence-ID the old dependence as well
--  as a list of new dependences with ID (after splitting)

--                      old ID        old Dep          new ID       new Dep
type DepSplitInfo = [(DependenceID, (Dependence, [(DependenceID, Dependence)]))]


-- |Map, which tells us to every old node of the parse tree and new statementID
--  the node number in the splitted tree

--                         new ID  old Node  new Node
type LaNodeSplitInfo = [((StatementID, Int), Int)]
