module ISS.Debug.Tests where



import LMath.Logic.Domain
import LMath.Types
import LMath.Types.IneqSystem
import LMath.Types.Matrix

import Data.Ratio

import LP
import ParseBase

testDomain :: IO ()
testDomain = do
               let dom = ineqToDomain2 Nothing (1, 1) ineq
                   ineq = ineqSystem ((1, 1), matrix)
                   matrix = setEntriesST (zeroMatrix 4 3) [(0,0,1), (0,1,0), (0,2,-1),
                                                           (1,0,-1),(1,1,0), (1,2,3),
                                                           (2,0,0), (2,1,1), (2,2,-2),
                                                           (3,0,0), (3,1,-1),(3,2,5)]
                   functionMatrix = setEntriesST (zeroMatrix 2 2) [(0,0,2), (0,1,0),
                                                                   (1,0,0), (1,1,1)]
                   function = affineFunction ((1,0),functionMatrix) Homogeneous
                   domProp = inverseImageD function dom
               putStrLn (show function)
               putStrLn (show domProp)

testPoly :: IO ()
testPoly = do
             let poly = linearCoeffs (constPolyN 5 17.0)
             putStrLn (show poly)

testAff :: IO ()
testAff = do
            ParseOk result <- loadAndParse "test.txt" parseAffineFunctionI
            putStrLn (show result)

{-
testKleene :: IO ()
testKleene = do
               putStrLn (show $ cleanPaths $ kleene edges nodes 0 2)
               putStrLn (show $ cleanPaths $ kleene edges nodes 2 2)
               putStrLn (show $ cleanPaths $ kleene edges nodes 0 0)

nodes :: [Integer]
nodes = [0, 1, 2]

edges :: Integer -> Integer -> [MyEdge Integer]
edges 0 1 = [MyEdge {name=1, source=0, dest=1}]
edges 0 2 = [MyEdge {name=3, source=0, dest=2}]
edges 1 0 = [MyEdge {name=2, source=1, dest=0}]
edges 1 2 = [MyEdge {name=5, source=1, dest=2}]
edges 2 2 = [MyEdge {name=4, source=2, dest=2}]
edges _ _ = []

data MyEdge a = MyEdge {name::a, source::Integer, dest::Integer}

instance Edge Integer (MyEdge Integer) where
    edgeSource = source
    edgeTarget = dest

instance (Show a) => Show (MyEdge a) where
    show = show . name
-}
