module InsertIfs.DS (Token(..), SourcePos(..), showPos) where

data Token = TComment String
	   | TBraceBegin
	   | TBraceEnd
	   | TParenBegin
	   | TParenEnd
	   | TAssign
	   | TSemi
	   | TComma
	   | TIf
	   | TFor
	   | TID String
	   | TWhitespaces String
	   | TUnknownChar Char
           deriving Show

-- |
-- Data type for source code positions.
--
data SourcePos = SourcePos Int -- line
		           Int -- column

instance Show SourcePos where
  show = showPos

-- |
-- Show a 'SourcePos' in the format
--   line 17, column 8
--
showPos :: SourcePos -> String
showPos (SourcePos line col) =
    concat ["line ", show line, ", column ", show col]
