module LMath.Tools
    ( module LMath.Tools.Qepcad,
      module LMath.Tools.Reduce,
      module LMath.Tools.ToolIO,
      factoriseP
    )
where

import LMath.Tools.ToolIO
import LMath.Tools.Qepcad
import LMath.Tools.Reduce

import LMath.Types.Polynomial

-- |
-- Factor a given polynomial.
-- Return the content of the polynomial and a
-- list of its primitive irreducible factors together
-- with their multiplicity.
--
factoriseP :: Integral a
           => Polynomial a
	   -> (a, [(Polynomial a, Integer)])
factoriseP = reduceFactoriseP
