-- |
-- This module re-exports all /LooPo/ modules.
--
-- Author: Armin Groesslinger
--
-- Version: $Id: Loopo.hs 3061 2005-10-18 16:03:16Z groessli $
--
module Loopo(module LMath,
	     module CppInterface,
	     module ParseBase, module LoopoDS,
	     module CodeGen, module Tiling,

             setTempDir,
             appendSessionLog
	    )

where


import LMath

import CppInterface
import ParseBase
import LoopoDS

import CodeGen
import Tiling

setTempDir :: FilePath -> IO ()
setTempDir = cppiConvert1 setTempDir_c
foreign import ccall setTempDir_c :: CString -> IO ()

appendSessionLog :: String -> IO ()
appendSessionLog = cppiConvert1 appendSessionLog_c
foreign import ccall appendSessionLog_c :: CString -> IO ()
