module LoopoDS.TRC
    ( TRC(..),
      readTRC
    )
where

import LMath
import ParseBase
import LoopoDS.IntegralID
import LoopoDS.Statement

data TRC = TRC { trcStmtID       :: StatementID, -- ^ original statement ID
		 trcTargetStmtID :: TStatementID,-- ^ transformed statement ID
		 trcConstraints  :: IneqSystem   -- ^ constraints
	       }
	   deriving (Show)
		  
readTRC :: FilePath -> IO (LPResult [TRC])
readTRC filename = loadAndParse filename parseTRCs
    where
    parseTRCs :: Parser [TRC]
    parseTRCs = do nStmt <- parseInteger
		   parseN nStmt parseTRC
    parseTRC :: Parser TRC
    parseTRC = do tstmt  <- parseInteger
		  stmt   <- parseInteger
		  constr <- parseIneqSystem
		  return $ TRC { trcStmtID = integerToID stmt,
				 trcTargetStmtID = integerToID tstmt,
				 trcConstraints = constr
			       }
