module ScannerParser.XMLHelper(findXMLSubnodes, onlyELNodes) where

import HXML.HXML

-- | Finds all subtree with pattern pat and returns the childs.
-- Used by ParseTree.fromXML.
findXMLSubnodes :: (XML -> Bool) -> XML -> [XML]
findXMLSubnodes pat xmlnode | pat xmlnode = treeChildren xmlnode
findXMLSubnodes _   (Tree _ [])           = []
findXMLSubnodes pat (Tree e (x:xs))       = (findXMLSubnodes pat x)++(findXMLSubnodes pat (Tree e xs))

-- | Helper function which deletes all nodes besides ELNodes.
onlyELNodes :: [XML] -> [XML]
onlyELNodes = filter oELn where
              oELn (Tree (ELNode _ _) _)  = True -- damit xml2LN nicht durch Comments oder
                                                 -- Textabschnitte aus dem Tritt kommt
              oELn _                      = False