module TestTiling where

import LMath.Types
import LoopoDS
import Tiling

import Ratio

is1 = ineqSystem ((2,2), matrix [[ (-1)%2,  1%1,  0%1,  1%2,  (-1)%1 ]
                                ,[ 0%1,  1%1,  0%1,  0%1,  (-1)%1 ]
                                ,[ 1%2,  (-1)%1,  0%1,  0%1,  (-1)%2 ]
                                ,[ 0%1,  (-1)%1,  1%1,  0%1,  0%1 ]
                                ,[ 1%1,  0%1,  0%1,  0%1,  (-3)%1 ]
                                ,[ (-1)%1,  0%1,  2%1,  1%1,  (-2)%1 ]
                                ,[ 0%1,  0%1,  0%1,  1%1,  (-3)%1 ]
                                ,[ 0%1,  0%1,  2%1,  1%1,  (-5)%1 ]
                                ,[ 0%1,  0%1,  1%1,  0%1,  (-1)%1 ]
			        ])

is2 = ineqSystem ((4,2), matrix [[ (-1)%2, 1%1, 1%2, (-1)%1, 0%1, 0%1, (-1)%2 ]
                                ,[1%2, (-1)%1, (-1)%2, 1%1, 0%1, 0%1, 1%2 ]
                                ,[1%1, 0%1, (-1)%1, 0%1, 0%1, 0%1, 1%1 ]
                                ,[(-1)%1, 0%1, 1%1, 0%1, 0%1, 0%1, (-1)%1 ]
                                ,[0%1, 1%1, 0%1, 0%1, 0%1, 0%1, (-2)%1 ]
                                ,[(-1)%2, 1%1, 0%1, 0%1, 0%1, 1%2, (-3)%2 ]
                                ,[1%2, (-1)%1, 0%1, 0%1, 0%1, 0%1, (-1)%2 ]
                                ,[0%1, (-1)%1, 0%1, 0%1, 1%1, 0%1, 0%1 ]
                                ,[1%1, 0%1, 0%1, 0%1, 0%1, 0%1, (-5)%1 ]
                                ,[(-1)%1, 0%1, 0%1, 0%1, 2%1, 1%1, (-3)%1 ]
                                ,[0%1, 0%1, 0%1, 0%1, 0%1, 1%1, (-4)%1 ]
                                ,[0%1, 0%1, 0%1, 0%1, 2%1, 1%1, (-8)%1 ]
                                ,[0%1, 0%1, 0%1, 0%1, 1%1, 0%1, (-2)%1 ]
			        ])

infos1 = [SrcTile]
infos2 = [SrcTile, DestTile]
lattice1 = [vector [1%1, 0%1]
           ,vector [0%1, 1%1]
           ]
lattice2 = [vector [5000%1, 0%1]
           ,vector [5000%1, 5000%1]
           ]
lattice3 = [vector [3737%1, 0%1]
           ,vector [0%1, 125000%1]
           ]
tiledDims = [0,1]
stmtID = integerToID 2

tileIS1 = fst $ defaultTile lattice1 tiledDims (selfDepRelation (stmtID, is1)) infos1

-- this time is2 already represents the dependence relation:
tileIS2 = fst $ defaultTile lattice2 tiledDims (simplifyIneqs Nothing is2, 2) infos2
-- use rectangular lattice here:
tileIS3 = fst $ defaultTile lattice3 tiledDims (simplifyIneqs Nothing is2, 2) infos2

rectTileIS1 = fst $ rectTile [1,1] (selfDepRelation (stmtID, is1)) infos1

rectTileIS3 = fst $ rectTile [3737,125000] (simplifyIneqs Nothing is2, 2) infos2

test = areIneqsEquivalent rectTileIS3 tileIS3 Nothing
