-- This module tests the functions VolIntCount.calcCloogVols and VolIntCount.runBarvinokCloog, where indexspaces of the type "Computes" are chosen.
--
-- Author: Malte Rosenthal

module Testing.VolIntCount.IneqComputesTests where

-- imports --------------------------------------------------------------------------------------------------------------------------------------------
import VolIntCount
import Time
import Monad

import NewCommCode

myMain :: IO ()
myMain = let	iMin = 1000
                iMax = 100000
		iStep = 2000
		jMin = 1000
		jMax = 100000
		jStep = 2000

		file = "results/work/ineqComputesResults.txt"
		tileI = [i | i <- [iMin..iMax], (i-iMin) `mod` iStep == 0]
		tileJ = [j | j <- [jMin..jMax], (j-jMin) `mod` jStep == 0]
		tmpdir = "../../../testdata"
		progs = ["adder", "fib", "gaussimple", "gauss-jordan", "lu-core", "matmult-imper", "matmult-systol", "pascal", "polyprod-func",
			 "polyprod-imper", "polyprod-systol", "sor1", "sor2"]
	 in do

    Monad.mapM_ (testTilmann	ineqComputes file tileI tileJ tmpdir) progs
    Monad.mapM_ (testBarvinok	ineqComputes file tileI tileJ tmpdir) progs
