-- This module tests the functions VolIntCount.calcVols and VolIntCount.runBarvinok
--
-- Author: Malte Rosenthal

module Testing.VolIntCount.NonCloogTests where

-- imports --------------------------------------------------------------------------------------------------------------------------------------------
import VolIntCount
import Time
import Monad

import NewCommCode

myMain :: IO ()
myMain = let	tmpdir = "../../../testdata"
		file = "results/work/nonCloogResults.txt"
		barvinokPath = "/public/packages/libraries/barvinok-0.22/bin/barvinok_enumerate"
	 in do
    appendFile file "----- calcVols ---------------------------------------------------------------"
   
    -- TODO: write functions :-)

    ct1 <- getClockTime
    appendFile file ("\n\nadder:\n" ++ show (calcVols tmpdir "adder.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))

    ct1 <- getClockTime
    appendFile file ("\n\nfib:\n" ++ show (calcVols tmpdir "fib.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))

    ct1 <- getClockTime
    appendFile file ("\n\ngaussimple:\n" ++ show (calcVols tmpdir "gaussimple.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    ct1 <- getClockTime
    appendFile file ("\n\ngauss-jordan:\n" ++ show (calcVols tmpdir "gauss-jordan.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    ct1 <- getClockTime
    appendFile file ("\n\nlu-core:\n" ++ show (calcVols tmpdir "lu-core.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    ct1 <- getClockTime
    appendFile file ("\n\nmatmult-imper:\n" ++ show (calcVols tmpdir "matmult-imper.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    ct1 <- getClockTime
    appendFile file ("\n\nmatmult-systol:\n" ++ show (calcVols tmpdir "matmult-systol.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    ct1 <- getClockTime
    appendFile file ("\n\npascal:\n" ++ show (calcVols tmpdir "pascal.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    ct1 <- getClockTime
    appendFile file ("\n\npolyprod-func:\n" ++ show (calcVols tmpdir "polyprod-func.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    ct1 <- getClockTime
    appendFile file ("\n\npolyprod-imper:\n" ++ show (calcVols tmpdir "polyprod-imper.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    ct1 <- getClockTime
    appendFile file ("\n\npolyprod-systol:\n" ++ show (calcVols tmpdir "polyprod-systol.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    ct1 <- getClockTime
    appendFile file ("\n\nsor1:\n" ++ show (calcVols tmpdir "sor1.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    ct1 <- getClockTime
    appendFile file ("\n\nsor2:\n" ++ show (calcVols tmpdir "sor2.src.out"))
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))

    appendFile file "\n----- runBarvinok ----------------------------------------------------------"
    
    appendFile file "\n\nadder:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "adder.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\nfib:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "fib.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\ngaussimple:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "gaussimple.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\ngauss-jordan:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "gauss-jordan.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\nlu-core:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "lu-core.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\nmatmult-imper:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "matmult-imper.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\nmatmult-systol:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "matmult-systol.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\npascal:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "pascal.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\npolyprod-func:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "polyprod-func.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\npolyprod-imper:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "polyprod-imper.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\npolyprod-systol:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "polyprod-systol.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\nsor1:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "sor1.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
    
    appendFile file "\n\nsor2:\n"
    ct1 <- getClockTime
    runBarvinok file barvinokPath tmpdir "sor2.src.out"
    ct2 <- getClockTime
    appendFile file ("\n" ++ show (diffClockTimes ct2 ct1))
