-- program to generate an allocation which has the 
-- Forward Communication Only property, if possible

import List
import Ratio
import Vector
import Loopo
import IOExts

----------------------------------------------------------------------
-- how to get input data from the ispc file
----------------------------------------------------------------------

load :: (FilePath -> IO (LPResult a)) -> FilePath -> IO a
load f file =
    do res <- f file
       case res of
           ParseOk x    -> return x
	   ParseFailed f -> error ("Fehler: " ++ show f)


readslpfile :: String -> IO ([(Integer,[Integer])])
readslpfile datei = 
     do resslps <- load readSLP (datei ++ ".slp")
	return resslps

readaccfile :: String -> IO ([(Integer, AccessType, Integer, Integer, AffineFunction)])
readaccfile datei = 
     do resaccs <- load readACC (datei ++ ".acc")
	return resaccs

domainOfStmt :: Integer -> [(Integer,IneqSystem)] -> IneqSystem
domainOfStmt stmntid  ispcs =  
    case ( find (\(s,d)-> stmntid==s) ispcs ) of
         Nothing    -> error("statement not found")
         Just (s,d) -> d



type Statement = (Integer,IneqSystem)

main :: IO()
main = mainx "exs/feautgasusssimple/gaussimple.src.out"

thrdOfThree (a,b,c) = c

mainx ::  String -> IO()
mainx datei =
    do 
--        stmts <- load readISPC (datei ++ ".ispc")  -- :: [Statement]
--        putStr(  (concat(intersperse "\r\n"  ( map (loopNest . snd) stmts ))))
       stmts <- load readTISPC (datei ++ ".tispc")  -- :: [Statement]
       putStr(  (concat(intersperse "\r\n"  ( map (loopNest . thrdOfThree) stmts ))))
